<template>
  <q-layout class="bg-grey-1">
    <Header/>
    <router-view/>
    <Notice :is-notice="isNotice" :notice="notice" @closed="isNotice = false"/>
  </q-layout>
  <Modal v-if="error.length">
    <template v-slot:body>
      <div class="text-2xl text-red-400 mb-6">Ошибка!</div>
      <div v-for="er in error" class="text-grey">
        <div>{{er.message}}</div>
        <div v-if="er?.err" class="mt-2 rounded px-2 flex no-wrap justify-between items-center bg-gray-600 text-black relative">
          <div class="truncate-1 text-xs">{{er.err}}</div>
          <q-btn v-if="!isCopy" @click="copyToClipboard(er.err)" class="absolute top-2 right-2" size="sm" color="gray" label="Копировать"/>
          <q-btn v-else round icon="check" class="absolute top-2 right-2" size="sm" color="green"/>
        </div>
      </div>
      <q-btn @click="spliceError" class="float-right mt-10" size="sm" color="green" label="ok"/>
    </template>
  </Modal>
</template>

<script>
import Header from "./components/Header.vue";
import Index from "./views/Main/Index.vue";
import {useStore} from "vuex";
import Notice from "./components/Notice.vue";
import api from "./API/api";
import {computed, onMounted, ref} from "vue";
import Modal from "./components/Modal.vue";

export default {
  components: {
    Modal,
    Index,
    Header,
    Notice,
  },

  setup() {
    const store = useStore()
    const isNotice = ref(false)
    const notice = ref([])
    const error = computed(() => store.state.error)
    const isCopy = ref(false)
    function spliceError () {
      isCopy.value=false
      store.dispatch('SPLICE_ERROR')
    }
    function copyToClipboard(el) {
      navigator.clipboard.writeText(el).then(function() {
        isCopy.value=true
      }).catch(function(err) {
        console.error('Не удалось скопировать текст: ', err);
      });
    }
    if (store.state.token || localStorage.token) {
      api.getLeadInfo().then(res => {
        if (res.data?.leadInfo?.length) {
          isNotice.value = true
          notice.value = res.data.leadInfo.reverse().filter(el => el.see)
        }
        else {
          isNotice.value = true
          notice.value = res.data.reverse().filter(el => el.see)
        }
      })
    }

    return {
      // user,
      error,
      spliceError,
      copyToClipboard,
      isCopy,
      notice,
      isNotice,
    }
  },
}
</script>
<style>
/*html {overflow: hidden!important;}*/
/*color rgb(36, 41, 46) grey-9*/
#app {overflow: hidden}
div, p, a {
  padding: 0;
  margin: 0;
}
</style>
